zoukankan      html  css  js  c++  java
  • HDU 3533 Escape(bfs)

    Escape

    Time Limit: 20000/10000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 598    Accepted Submission(s): 153
    Problem Description
    The students of the HEU are maneuvering for their military training.
    The red army and the blue army are at war today. The blue army finds that Little A is the spy of the red army, so Little A has to escape from the headquarters of the blue army to that of the red army. The battle field is a rectangle of size m*n, and the headquarters of the blue army and the red army are placed at (0, 0) and (m, n), respectively, which means that Little A will go from (0, 0) to (m, n). The picture below denotes the shape of the battle field and the notation of directions that we will use later.



    The blue army is eager to revenge, so it tries its best to kill Little A during his escape. The blue army places many castles, which will shoot to a fixed direction periodically. It costs Little A one unit of energy per second, whether he moves or not. If he uses up all his energy or gets shot at sometime, then he fails. Little A can move north, south, east or west, one unit per second. Note he may stay at times in order not to be shot.
    To simplify the problem, let’s assume that Little A cannot stop in the middle of a second. He will neither get shot nor block the bullet during his move, which means that a bullet can only kill Little A at positions with integer coordinates. Consider the example below. The bullet moves from (0, 3) to (0, 0) at the speed of 3 units per second, and Little A moves from (0, 0) to (0, 1) at the speed of 1 unit per second. Then Little A is not killed. But if the bullet moves 2 units per second in the above example, Little A will be killed at (0, 1).
    Now, please tell Little A whether he can escape.
     
    Input
    For every test case, the first line has four integers, m, n, k and d (2<=m, n<=100, 0<=k<=100, m+ n<=d<=1000). m and n are the size of the battle ground, k is the number of castles and d is the units of energy Little A initially has. The next k lines describe the castles each. Each line contains a character c and four integers, t, v, x and y. Here c is ‘N’, ‘S’, ‘E’ or ‘W’ giving the direction to which the castle shoots, t is the period, v is the velocity of the bullets shot (i.e. units passed per second), and (x, y) is the location of the castle. Here we suppose that if a castle is shot by other castles, it will block others’ shots but will NOT be destroyed. And two bullets will pass each other without affecting their directions and velocities.
    All castles begin to shoot when Little A starts to escape.
    Proceed to the end of file.
     
    Output
    If Little A can escape, print the minimum time required in seconds on a single line. Otherwise print “Bad luck!” without quotes.
     
    Sample Input
    4 4 3 10 N 1 1 1 1 W 1 1 3 2 W 2 1 2 4 4 4 3 10 N 1 1 1 1 W 1 1 3 2 W 1 1 2 4
     
    Sample Output
    9 Bad luck!
     
    Source
     
    题意:
    一个人从(0,0)跑到(n,m),只有k点能量,一秒消耗一点,在图中有k个炮塔,给出炮塔的射击方向c,射击间隔t,子弹速度v,坐标x,y
    问这个人能不能安全到达终点
    要求: 
    1.人不能到达炮塔所在的坐标
    2.炮塔会挡住子弹
    3.途中遇到子弹是安全的,但是人如果停在这个坐标,而子弹也刚好到这个坐标,人就被射死
    4.人可以选择停止不动
     
    思路:其实不难,我们只需要看当人位于某个点的时候,其四个方向是否有炮塔,这个炮塔是都向人的方向射击,然后再看子弹是否刚好位于这个坐标即可。
    而标记的话,vis[x][y][time],对于time时刻,人位于x,y的情况只需要访问一次,这是唯一的
    我的代码:
    /*************************************************************************
        > File Name:            hdu_3533.cpp
        > Author:               Howe_Young
        > Mail:                 1013410795@qq.com
        > Created Time:         2015年04月28日 星期二 19时14分24秒
     ************************************************************************/
    
    #include <cstdio>
    #include <iostream>
    #include <cstring>
    #include <cmath>
    #include <cstdlib>
    #include <algorithm>
    #include <queue>
    
    using namespace std;
    const int maxn = 103;
    const int Next[5][2] = {0, 1, 1, 0, 0, -1, -1, 0, 0, 0};//可以四个方向,也可以呆在原地不动 
    int n, m, k, d;
    struct castle{//碉堡 
        char dir;//炮塔方向 
        int t, v;//t是周期,v是速度 
    };
    struct Node{
        int x, y, step;
    };
    castle bullet[maxn][maxn];
    bool vis[maxn][maxn][1004];
    bool check(Node node)
    {
        return (node.x < 0 || node.y < 0 || node.x > m || node.y > n);
    }
    void bfs()
    {
        memset(vis, false, sizeof(vis));
        queue<Node> Q;
        Node cur, next;
        cur.x = cur.y = cur.step = 0;
        vis[0][0][0] = true;
        Q.push(cur);
        while (!Q.empty())
        {
            bool flag;
            cur = Q.front();
            Q.pop();
            if (cur.step > d)
                break;
            if (cur.x == m && cur.y == n)
            {
                printf("%d
    ", cur.step);
                return;
            }
            for (int i = 0; i < 5; i++)
            {
                next.x = cur.x + Next[i][0];
                next.y = cur.y + Next[i][1];
                next.step = cur.step + 1;
                if (check(next))
                    continue;
                //这里前面那个是判断此点是否有碉堡,如果有碉堡的话不能走 
                if (bullet[next.x][next.y].t == 0 && !vis[next.x][next.y][next.step] && next.step <= d)
                {
                    flag = true;
                    for (int j = next.x - 1; j >= 0; j--)//向上找有没有碉堡 
                    {
                        if (bullet[j][next.y].t != 0 && bullet[j][next.y].dir == 'S')//说明有碉堡.并且朝南
                        {
                            int dis = next.x - j;//碉堡与人的距离 
                            if (dis % bullet[j][next.y].v != 0)//如果不能整除的话,说明子弹在这个点时肯定不是整点,所以直接跳过 
                                break;
                            int tmp = next.step - dis / bullet[j][next.y].v;//人走的总时间减去第一颗子弹到这需要多少时间 
                            if (tmp < 0)//如果人到这,子弹还到不了,所以安全,直接跳过 
                                break;
                            if (tmp % bullet[j][next.y].t == 0)//如果子弹正好到这,这时人就被打死了 
                            {
                                flag = false;
                                break;
                            }
                        }
                        if (bullet[j][next.y].t != 0)//如果炮塔不朝南的话就直接挡住子弹了
                            break;
                    }
                    if (!flag)
                        continue;
                        //下面其他三个方向同理 
                    for (int j = next.x + 1; j <= m; j++)
                    {
                        if (bullet[j][next.y].t != 0 && bullet[j][next.y].dir == 'N')
                        {
                            int dis = j - next.x;
                            if (dis % bullet[j][next.y].v != 0)
                                break;
                            int tmp = next.step - dis / bullet[j][next.y].v;
                            if (tmp < 0)
                                break;
                            if (tmp % bullet[j][next.y].t == 0)
                            {
                                flag = false;
                                break;
                            }
                        }
                        if (bullet[j][next.y].t != 0)
                            break;
                    }
                    if (!flag)
                        continue;
                    for (int j = next.y - 1; j >= 0; j--)
                    {
                        if (bullet[next.x][j].t != 0 && bullet[next.x][j].dir == 'E')
                        {
                            int dis = next.y - j;
                            if (dis % bullet[next.x][j].v != 0)
                                break;
                            int tmp = next.step - dis / bullet[next.x][j].v;
                            if (tmp < 0)
                                break;
                            if (tmp % bullet[next.x][j].t == 0)
                            {
                                flag = false;
                                break;
                            }
                        }
                        if (bullet[next.x][j].t != 0)
                            break;
                    }
                    if (!flag)
                        continue;
                    for (int j = next.y + 1; j <= n; j++)
                    {
                        if (bullet[next.x][j].t != 0 && bullet[next.x][j].dir == 'W')
                        {
                            int dis = j - next.y;
                            if (dis % bullet[next.x][j].v != 0)
                                break;
                            int tmp = next.step - dis / bullet[next.x][j].v;
                            if (tmp < 0)
                                break;
                            if (tmp % bullet[next.x][j].t == 0)
                            {
                                flag = false;
                                break;
                            }
                        }
                        if (bullet[next.x][j].t != 0)
                            break;
                    }
                    if (!flag)
                        continue;
                    vis[next.x][next.y][next.step] = true;
                    Q.push(next);
                }
            }
        }
        printf("Bad luck!
    ");
    }
    int main()
    {
        while (~scanf("%d %d %d %d", &m, &n, &k, &d))
        {
            char ch;
            int a, b, c, d;
            memset(bullet, 0, sizeof(bullet));
            for (int i = 0; i < k; i++)
            {
                cin >> ch >> a >> b >> c >> d;
                bullet[c][d].dir = ch;
                bullet[c][d].t = a;
                bullet[c][d].v = b;
            }
            bfs();
        }
        return 0;
    }
    View Code
  • 相关阅读:
    函数和递归
    对象
    数组
    For...In 声明
    JavaScript 变量的生存期
    Hadoop Hive与Hbase整合+thrift
    朱子治家格言
    大学
    《孙子兵法》【谋攻第三】
    棋经十三篇
  • 原文地址:https://www.cnblogs.com/Howe-Young/p/4465548.html
Copyright © 2011-2022 走看看